Debian Bug report logs - #540512
dash upgrade breaks mksh-as-/bin/sh

version graph

Package: dash; Maintainer for dash is Gerrit Pape <pape@smarden.org>; Source for dash is src:dash.

Reported by: Thorsten Glaser <tg@mirbsd.de>

Date: Sat, 8 Aug 2009 14:03:01 UTC

Severity: grave

Tags: squeeze-ignore, wheezy-ignore

Found in version dash/0.5.5.1-2.2

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, tg@mirbsd.de, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Sat, 08 Aug 2009 14:03:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thorsten Glaser <tg@mirbsd.de>:
New Bug report received and forwarded. Copy sent to tg@mirbsd.de, Gerrit Pape <pape@smarden.org>. (Sat, 08 Aug 2009 14:03:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Thorsten Glaser <tg@mirbsd.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dash upgrade breaks mksh-as-/bin/sh
Date: Sat, 08 Aug 2009 13:44:20 +0000
Package: dash
Version: 0.5.5.1-2.3
Severity: normal

I had dash/sh=false and mksh/sh=true so /bin/sh@ -> mksh

Preparing to replace dash 0.5.5.1-2.1 (using .../dash_0.5.5.1-2.3_i386.deb) ...
Unpacking replacement dash ...
dpkg: error processing /var/cache/apt/archives/dash_0.5.5.1-2.3_i386.deb (--unpack):
 trying to overwrite `/usr/share/man/man1/sh.1.gz', which is also in package bash
Processing triggers for man-db ...
Processing triggers for menu ...
Errors were encountered while processing:
 /var/cache/apt/archives/dash_0.5.5.1-2.3_i386.deb
E: Sub-process /usr/bin/dpkg returned an error code (1)

I do a “sudo dpkg-reconfigure mksh” to set mksh/sh=false,
then I have /bin/sh@ -> bash

Now, the “sudo apt-get dist-upgrade” succeeds.
Afterwards, mksh/sh=false and dash/sh=false still.

Then I “sudo dpkg-reconfigure mksh” to set mksh/sh=true,
but I still have /bin/sh@ -> bash


I consider both of this (failure to upgrade dash if mksh is
/bin/sh, and failure to set /bin/sh back to mksh after dash
upgrade) bugs.

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)

Kernel: Linux 2.6.18-6-686 (SMP w/1 CPU core)
Locale: LANG=C, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages dash depends on:
ii  debianutils                   3.2        Miscellaneous utilities specific t
ii  dpkg                          1.15.3.1   Debian package management system
ii  libc6                         2.9-23     GNU C Library: Shared libraries

dash recommends no packages.

dash suggests no packages.

-- debconf information:
* dash/sh: false




Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 10 Aug 2009 08:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 10 Aug 2009 08:03:07 GMT) Full text and rfc822 format available.

Message #10 received at 540512@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: Thorsten Glaser <tg@mirbsd.de>
Cc: 540512@bugs.debian.org
Subject: Re: Bug#540512: dash upgrade breaks mksh-as-/bin/sh
Date: Mon, 10 Aug 2009 09:49:46 +0200
severity 540512 grave
merge 538822 540512
thanks

On 2009-08-08 15:44 +0200, Thorsten Glaser wrote:

> Package: dash
> Version: 0.5.5.1-2.3
> Severity: normal
>
> I had dash/sh=false and mksh/sh=true so /bin/sh@ -> mksh
>
> Preparing to replace dash 0.5.5.1-2.1 (using .../dash_0.5.5.1-2.3_i386.deb) ...
> Unpacking replacement dash ...
> dpkg: error processing /var/cache/apt/archives/dash_0.5.5.1-2.3_i386.deb (--unpack):
>  trying to overwrite `/usr/share/man/man1/sh.1.gz', which is also in package bash

This is #538822, the reason being that both bash and dash ship this
file.  The dash preinst diverts it, but only if a diversion is not
already in place.  In that case, both dash's and bash's version would be
diverted, causing the file conflict.

> Processing triggers for man-db ...
> Processing triggers for menu ...
> Errors were encountered while processing:
>  /var/cache/apt/archives/dash_0.5.5.1-2.3_i386.deb
> E: Sub-process /usr/bin/dpkg returned an error code (1)
>
> I do a “sudo dpkg-reconfigure mksh” to set mksh/sh=false,
> then I have /bin/sh@ -> bash
>
> Now, the “sudo apt-get dist-upgrade” succeeds.
> Afterwards, mksh/sh=false and dash/sh=false still.
>
> Then I “sudo dpkg-reconfigure mksh” to set mksh/sh=true,
> but I still have /bin/sh@ -> bash

Because dash now always sets up a diversion, and you cannot have more
than one package divert the same file (see #273093).

Sven




Severity set to 'grave' from 'normal' Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Mon, 10 Aug 2009 08:03:09 GMT) Full text and rfc822 format available.

Merged 538822 540512. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Mon, 10 Aug 2009 08:03:11 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 10 Aug 2009 13:21:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thorsten Glaser <tg@mirbsd.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 10 Aug 2009 13:21:07 GMT) Full text and rfc822 format available.

Message #19 received at 540512@bugs.debian.org (full text, mbox):

From: Thorsten Glaser <tg@mirbsd.de>
To: Sven Joachim <svenjoac@gmx.de>
Cc: 540512@bugs.debian.org, 538822@bugs.debian.org, control@bugs.debian.org
Subject: Re: Bug#540512: dash upgrade breaks mksh-as-/bin/sh
Date: Mon, 10 Aug 2009 13:19:06 +0000 (UTC)
block 539538 by 538822
block 535970 by 538822
block 532343 by 538822
block 534788 by 538822
thanks

Sven Joachim dixit:

>Because dash now always sets up a diversion, and you cannot have more
>than one package divert the same file (see #273093).

Ah, great. So there now is *no* way to tell dash to not divert it?

We *really* need to have something like a shared/binsh debconf,
like the debconf docs show for window-manager.

This is blocking my upload of an updated mksh.

//mirabilos
-- 
“It is inappropriate to require that a time represented as
 seconds since the Epoch precisely represent the number of
 seconds between the referenced time and the Epoch.”
	-- IEEE Std 1003.1b-1993 (POSIX) Section B.2.2.2




Added indication that bug 540512 blocks539538 Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Mon, 10 Aug 2009 13:21:08 GMT) Full text and rfc822 format available.

Added indication that bug 540512 blocks535970 Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Mon, 10 Aug 2009 13:21:09 GMT) Full text and rfc822 format available.

Added indication that bug 540512 blocks532343 Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Mon, 10 Aug 2009 13:21:10 GMT) Full text and rfc822 format available.

Added indication that bug 540512 blocks534788 Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Mon, 10 Aug 2009 13:21:11 GMT) Full text and rfc822 format available.

Added indication that bug 540512 blocks539538 Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Mon, 10 Aug 2009 13:51:05 GMT) Full text and rfc822 format available.

Added indication that bug 540512 blocks535970 Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Mon, 10 Aug 2009 13:51:15 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 10 Aug 2009 17:00:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 10 Aug 2009 17:00:07 GMT) Full text and rfc822 format available.

Message #36 received at 540512@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: Thorsten Glaser <tg@mirbsd.de>
Cc: 540512@bugs.debian.org, 538822@bugs.debian.org
Subject: Re: Bug#540512: dash upgrade breaks mksh-as-/bin/sh
Date: Mon, 10 Aug 2009 18:57:30 +0200
On 2009-08-10 15:19 +0200, Thorsten Glaser wrote:

> Sven Joachim dixit:
>
>>Because dash now always sets up a diversion, and you cannot have more
>>than one package divert the same file (see #273093).
>
> Ah, great. So there now is *no* way to tell dash to not divert it?

Apparently not.  But even if there were, it would trigger the file
conflict in #538822 because *both dash and bash* ship /bin/sh now.
AFAICS the only possibility to have another package take over /bin/sh is
to remove it from either dash or bash.

> We *really* need to have something like a shared/binsh debconf,
> like the debconf docs show for window-manager.

Do you have an idea how to implement that?  Managing /bin/sh through the
alternatives system does not seem very prudent.

Regards,
        Sven




Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 10 Aug 2009 17:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thorsten Glaser <tg@mirbsd.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 10 Aug 2009 17:21:03 GMT) Full text and rfc822 format available.

Message #41 received at 540512@bugs.debian.org (full text, mbox):

From: Thorsten Glaser <tg@mirbsd.de>
To: Sven Joachim <svenjoac@gmx.de>
Cc: 540512@bugs.debian.org, 538822@bugs.debian.org
Subject: Re: Bug#540512: dash upgrade breaks mksh-as-/bin/sh
Date: Mon, 10 Aug 2009 17:13:27 +0000 (UTC)
Sven Joachim dixit:

>Do you have an idea how to implement that?  Managing /bin/sh through the
>alternatives system does not seem very prudent.

No, diversions are fine for that, I'd think. But I'm not a
debconf expert.

//mirabilos
-- 
“It is inappropriate to require that a time represented as
 seconds since the Epoch precisely represent the number of
 seconds between the referenced time and the Epoch.”
	-- IEEE Std 1003.1b-1993 (POSIX) Section B.2.2.2




Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 10 Aug 2009 17:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Luk Claes <luk@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 10 Aug 2009 17:33:03 GMT) Full text and rfc822 format available.

Message #46 received at 540512@bugs.debian.org (full text, mbox):

From: Luk Claes <luk@debian.org>
To: Thorsten Glaser <tg@mirbsd.de>, 538822@bugs.debian.org, Guillem Jover <guillem@debian.org>
Cc: Sven Joachim <svenjoac@gmx.de>, 540512@bugs.debian.org
Subject: Re: Bug#538822: Bug#540512: dash upgrade breaks mksh-as-/bin/sh
Date: Mon, 10 Aug 2009 19:29:58 +0200
Thorsten Glaser wrote:
> Sven Joachim dixit:
> 
>> Do you have an idea how to implement that?  Managing /bin/sh through the
>> alternatives system does not seem very prudent.
> 
> No, diversions are fine for that, I'd think. But I'm not a
> debconf expert.

I thought Guillem was going to talk to you to see what the best way was
to make sure mksh could provide /bin/sh (I've put him in Cc).

Guillem: do you think the only sane way out is to not have bash ship
/bin/sh? If so, how would bash preferably be adapted?

Cheers

Luk




Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 10 Aug 2009 19:57:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thorsten Glaser <tg@mirbsd.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 10 Aug 2009 19:57:07 GMT) Full text and rfc822 format available.

Message #51 received at 540512@bugs.debian.org (full text, mbox):

From: Thorsten Glaser <tg@mirbsd.de>
To: Luk Claes <luk@debian.org>
Cc: 538822@bugs.debian.org, Guillem Jover <guillem@debian.org>, Sven Joachim <svenjoac@gmx.de>, 540512@bugs.debian.org
Subject: Re: Bug#538822: Bug#540512: dash upgrade breaks mksh-as-/bin/sh
Date: Mon, 10 Aug 2009 19:51:30 +0000 (UTC)
Luk Claes dixit:

>I thought Guillem was going to talk to you to see what the best way was

Hm, haven't received any yet...

>to make sure mksh could provide /bin/sh (I've put him in Cc).

Might want to consider ksh93 too. It also attempts to follow
POSIX closely, I even had Dave Korn in in the recent "set -u"
vs "$@" discussion.

Greets,
//mirabilos
-- 
Sometimes they [people] care too much: pretty printers [and syntax highligh-
ting, d.A.] mechanically produce pretty output that accentuates irrelevant
detail in the program, which is as sensible as putting all the prepositions
in English text in bold font.	-- Rob Pike in "Notes on Programming in C"




Added indication that 540512 affects mksh Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Sat, 15 Aug 2009 12:36:02 GMT) Full text and rfc822 format available.

Added indication that bug 540512 blocks541617 Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Sat, 15 Aug 2009 12:36:07 GMT) Full text and rfc822 format available.

Added indication that bug 540512 blocks541617 Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Sat, 15 Aug 2009 12:36:08 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions dash/0.5.5.1-2, dash/0.5.5.1-2.3, and dash/0.5.5.1-2.2. Request was from Gerrit Pape <pape@dbnbgs.smarden.org> to control@bugs.debian.org. (Fri, 26 Mar 2010 15:36:05 GMT) Full text and rfc822 format available.

Bug Marked as found in versions dash/0.5.5.1-2.2. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Tue, 06 Apr 2010 07:42:12 GMT) Full text and rfc822 format available.

Disconnected #538822 from all other report(s). Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Mon, 01 Nov 2010 02:57:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Sun, 26 Dec 2010 17:33:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Sun, 26 Dec 2010 17:33:09 GMT) Full text and rfc822 format available.

Message #68 received at 540512@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 540512@bugs.debian.org, 538822@bugs.debian.org, release-notes@packages.debian.org
Subject: dash and local diversions
Date: Sun, 26 Dec 2010 18:29:53 +0100
[Message part 1 (text/plain, inline)]
user release.debian.org@packages.debian.org
usertag 540512 squeeze-can-defer
usertag 538822 squeeze-can-defer
tag 540512 squeeze-ignore
tag 538822 squeeze-ignore
affects 540512 + release-notes
affects 538822 + release-notes
kthxbye

Hi,

the release notes for squeeze will need to mention that any local
diversions of /bin/sh need to be removed prior to the upgrade.  Any more
tweaking of this code path to support other shells as /bin/sh, if at all
necessary, will wait for post-squeeze.

Cheers,
Julien
[signature.asc (application/pgp-signature, inline)]

Added tag(s) squeeze-ignore. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Sun, 26 Dec 2010 17:33:10 GMT) Full text and rfc822 format available.

Added indication that 540512 affects release-notes Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Sun, 26 Dec 2010 17:33:11 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 27 Dec 2010 21:30:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Adam D. Barratt" <adam@adam-barratt.org.uk>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 27 Dec 2010 21:30:05 GMT) Full text and rfc822 format available.

Message #77 received at 540512@bugs.debian.org (full text, mbox):

From: "Adam D. Barratt" <adam@adam-barratt.org.uk>
To: Julien Cristau <jcristau@debian.org>, 538822@bugs.debian.org
Cc: 540512@bugs.debian.org, release-notes@packages.debian.org, 538822-submitter@bugs.debian.org, 540512-submitter@bugs.debian.org
Subject: Re: Bug#538822: dash and local diversions
Date: Mon, 27 Dec 2010 21:27:29 +0000
[Message part 1 (text/plain, inline)]
On Sun, 2010-12-26 at 18:29 +0100, Julien Cristau wrote:
> the release notes for squeeze will need to mention that any local
> diversions of /bin/sh need to be removed prior to the upgrade.  Any more
> tweaking of this code path to support other shells as /bin/sh, if at all
> necessary, will wait for post-squeeze.

I put together a proposed patch (attached) for the Release Notes,
listing this as a potential problem in the "Issues to be aware of"
section; comments welcome.

Regards,

Adam
[squeeze-rn-shell-diversions.diff (text/x-patch, attachment)]

Message sent on to Thorsten Glaser <tg@mirbsd.de>:
Bug#540512. (Mon, 27 Dec 2010 21:30:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 27 Dec 2010 21:57:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thorsten Glaser <tg@mirbsd.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 27 Dec 2010 21:57:05 GMT) Full text and rfc822 format available.

Message #85 received at 540512@bugs.debian.org (full text, mbox):

From: Thorsten Glaser <tg@mirbsd.de>
To: "Adam D. Barratt" <adam@adam-barratt.org.uk>, 540512@bugs.debian.org
Cc: Julien Cristau <jcristau@debian.org>, 538822@bugs.debian.org, 540512@bugs.debian.org, release-notes@packages.debian.org, 538822-submitter@bugs.debian.org
Subject: Re: Bug#540512: Bug#538822: dash and local diversions
Date: Mon, 27 Dec 2010 21:52:31 +0000 (UTC)
Adam D. Barratt dixit:

>I put together a proposed patch (attached) for the Release Notes,

Looks good to me, thanks. (Indeed, I should have known the issue,
but forgot that these were its symptoms.)

bye,
//mirabilos
-- 
Support mksh as /bin/sh and RoQA dash NOW!
‣ src:bash (241 (259) bugs: 0 RC, 172 (187) I&N, 69 (82) M&W, 0 F&P)
‣ src:dash (74 (82) bugs: 3 (4) RC, 51 (57) I&N, 20 (21) M&W, 0 F&P)
‣ src:mksh (4 bugs: 0 RC, 0 I&N, 4 M&W, 0 F&P)




Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Wed, 29 Dec 2010 19:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Adam D. Barratt" <adam@adam-barratt.org.uk>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Wed, 29 Dec 2010 19:51:05 GMT) Full text and rfc822 format available.

Message #90 received at 540512@bugs.debian.org (full text, mbox):

From: "Adam D. Barratt" <adam@adam-barratt.org.uk>
To: Thorsten Glaser <tg@mirbsd.de>, 538822@bugs.debian.org
Cc: 540512@bugs.debian.org, Julien Cristau <jcristau@debian.org>, release-notes@packages.debian.org, 538822-submitter@bugs.debian.org
Subject: Re: Bug#538822: Bug#540512: Bug#538822: dash and local diversions
Date: Wed, 29 Dec 2010 19:45:38 +0000
On Mon, 2010-12-27 at 21:52 +0000, Thorsten Glaser wrote:
> Adam D. Barratt dixit:
> 
> >I put together a proposed patch (attached) for the Release Notes,
> 
> Looks good to me, thanks. (Indeed, I should have known the issue,
> but forgot that these were its symptoms.)

Thanks.  Any comments / additions from others?

Regards,

Adam





Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Thu, 30 Dec 2010 18:18:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Thu, 30 Dec 2010 18:18:05 GMT) Full text and rfc822 format available.

Message #95 received at 540512@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: "Adam D. Barratt" <adam@adam-barratt.org.uk>, 538822@bugs.debian.org
Cc: Thorsten Glaser <tg@mirbsd.de>, 540512@bugs.debian.org, release-notes@packages.debian.org, 538822-submitter@bugs.debian.org
Subject: Re: Bug#538822: Bug#540512: Bug#538822: dash and local diversions
Date: Thu, 30 Dec 2010 19:14:56 +0100
[Message part 1 (text/plain, inline)]
On Wed, Dec 29, 2010 at 19:45:38 +0000, Adam D. Barratt wrote:

> On Mon, 2010-12-27 at 21:52 +0000, Thorsten Glaser wrote:
> > Adam D. Barratt dixit:
> > 
> > >I put together a proposed patch (attached) for the Release Notes,
> > 
> > Looks good to me, thanks. (Indeed, I should have known the issue,
> > but forgot that these were its symptoms.)
> 
> Thanks.  Any comments / additions from others?
> 
Patch committed (r7973), thanks.

Cheers,
Julien
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Sat, 01 Jan 2011 23:03:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Sat, 01 Jan 2011 23:03:04 GMT) Full text and rfc822 format available.

Message #100 received at 540512@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: "Adam D. Barratt" <adam@adam-barratt.org.uk>, 538822@bugs.debian.org
Cc: Thorsten Glaser <tg@mirbsd.de>, 540512@bugs.debian.org, release-notes@packages.debian.org, 538822-submitter@bugs.debian.org
Subject: Re: Bug#538822: Bug#540512: Bug#538822: dash and local diversions
Date: Sat, 1 Jan 2011 23:57:50 +0100
[Message part 1 (text/plain, inline)]
affects 538822 - release-notes
affects 540512 - release-notes
kthxbye

On Thu, Dec 30, 2010 at 19:14:56 +0100, Julien Cristau wrote:

> Patch committed (r7973), thanks.
> 
Removing the release-notes 'affects' from those bugs to get them out of
my todo list :)

Cheers,
Julien
[signature.asc (application/pgp-signature, inline)]

Removed indication that 540512 affects release-notes Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Sat, 01 Jan 2011 23:03:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Thu, 13 Jan 2011 13:03:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Thu, 13 Jan 2011 13:03:08 GMT) Full text and rfc822 format available.

Message #107 received at 540512@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: "Adam D. Barratt" <adam@adam-barratt.org.uk>, 538822@bugs.debian.org
Cc: Julien Cristau <jcristau@debian.org>, 540512@bugs.debian.org
Subject: Re: Bug#538822: dash and local diversions
Date: Thu, 13 Jan 2011 13:34:31 +0100
Hi,

I am the submitter of the original dash upgrade bug.

On Mon, Dec 27, 2010 at 09:27:29PM +0000, Adam D. Barratt wrote:
> diff --git a/en/issues.dbk b/en/issues.dbk
> index 9498399..83f1408 100644
> --- a/en/issues.dbk
> +++ b/en/issues.dbk
> @@ -244,6 +244,34 @@ works for <literal>root</literal>.
>    </para>
>  </section>
>  
> +<section id="shell-diversions">
> +  <title>Potential issues with diversions of /bin/sh</title>
> +  <para>
> +    If you have previously added a local diversion for <literal>/bin/sh</literal>,
> +    or modified the <literal>/bin/sh</literal> symlink to point to somewhere
> +    other than <literal>/bin/bash</literal>, then you may encounter problems
> +    when upgrading the <systemitem role="package">dash</systemitem> or
> +    <systemitem role="package">bash</systemitem> packages.
> +    Note that this includes changes made by allowing other packages (for example
> +    <systemitem role="package">mksh</systemitem>) to become the default system
> +    shell by taking over <literal>/bin/sh</literal>.
> +  </para>
> +  <para>
> +    If you encounter any such issues, please remove the local diversion and
> +    ensure that the symlinks for both <literal>/bin/sh</literal> and its
> +    manual page point to the files provided by the <systemitem role="package">
> +    bash</systemitem> package and then
> +    <command>dpkg-reconfigure --force dash</command>.
> +  </para>
> +  <programlisting>
> +    dpkg-divert --remove /bin/sh
> +    dpkg-divert --remove /usr/share/man/man1/sh.1.gz
> +    
> +    ln -sf bash /bin/sh
> +    ln -sf bash.1.gz /usr/share/man/man1/sh.1.gz
> +  </programlisting>
> +</section>
> +
>  </section>
>  
>  <section id="upgrade-to-2.6" condition="fixme">

I verified that the steps you proposed solved the issue on my system.

Thank you very much for finally (after one and a half year) addressing
the issue.

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Wed, 02 Feb 2011 22:51:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thorsten Glaser <tg@mirbsd.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Wed, 02 Feb 2011 22:51:10 GMT) Full text and rfc822 format available.

Message #112 received at 540512@bugs.debian.org (full text, mbox):

From: Thorsten Glaser <tg@mirbsd.de>
To: 540512@bugs.debian.org
Subject: Re: dash: dash upgrade breaks mksh-as-/bin/sh
Date: Wed, 2 Feb 2011 22:37:44 +0000 (UTC)
Hi,

for additional consideration of any solution: the current binary pak-
kage “mksh” comes with two shells “mksh” and “mksh-static”, and both
are suitable for use as /bin/sh (mksh-static even more so on ports
like m68k where the reduced startup time is noticeable).

So any solution should not use a binary package’s name as only key.

(It was recently re-suggested I split mksh, but back when I first
made the source package, waldi said binary packages are too expen-
sive a ressource, so it was decided against. Unless there is demand
for the split and an okay from ftpteam. Also, mksh-static is cur-
rently using dietlibc if available, eglibc otherwise; I prefer to
use klibc once it works though, so there will be three possibilities
in the future – four might, if we get µClibc.)

bye,
//mirabilos
-- 
22:20⎜<asarch> The crazy that persists in his craziness becomes a master
22:21⎜<asarch> And the distance between the craziness and geniality is
only measured by the success                       22:21⎜<mksh> it’s a
very thin line anyway… with some, you don’t know which side they’re on




Added indication that bug 540512 blocks 619820 Request was from Holger Levsen <holger@layer-acht.org> to control@bugs.debian.org. (Mon, 28 Mar 2011 10:15:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 11 Apr 2011 08:00:29 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 11 Apr 2011 08:00:29 GMT) Full text and rfc822 format available.

Message #119 received at 540512@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: 538822@bugs.debian.org, 540512@bugs.debian.org
Cc: 538822-submitter@bugs.debian.org, 540512-submitter@bugs.debian.org
Subject: Re: Shipping /bin/sh
Date: Mon, 11 Apr 2011 02:57:29 -0500
tags 538822 + patch
tags 540512 + patch
# unrelated:
unblock 619820 by 540512
quit

Hi,

Sven Joachim wrote:

> This is #538822, the reason being that both bash and dash ship this
> file.

I've put up a fix at

- git://repo.or.cz/dash/debian/jrn.git proposed-updates
- http://mentors.debian.net/debian/pool/main/d/dash/dash_0.5.6.1-1~exp3.dsc

It uses an old trick from Michael Stone (as explained by ajt), from
<http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=85;bug=34717>.

Known bug: the /bin/sh link switches to bash and back to dash if dash
and bash are being upgraded in a single dpkg run on a typical
installation.  Seems harmless.  Fixing that would require a small
change to bash's preinst.

Please feel free to test bootstraps and weird scenarios and let me
know how it goes.  After a few days I would be interested in uploading
this to experimental.

Thanks, and hope that helps.
Jonathan




Added tag(s) patch. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Mon, 11 Apr 2011 08:00:33 GMT) Full text and rfc822 format available.

Removed indication that bug 540512 blocks 619820 Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Mon, 11 Apr 2011 08:00:35 GMT) Full text and rfc822 format available.

Message sent on to Thorsten Glaser <tg@mirbsd.de>:
Bug#540512. (Mon, 11 Apr 2011 08:00:48 GMT) Full text and rfc822 format available.

Removed tag(s) patch. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Tue, 27 Sep 2011 01:18:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Mon, 29 Oct 2012 19:27:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Gevers <elbrus@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Mon, 29 Oct 2012 19:27:05 GMT) Full text and rfc822 format available.

Message #133 received at 540512@bugs.debian.org (full text, mbox):

From: Paul Gevers <elbrus@debian.org>
To: 540512@bugs.debian.org, 538822@bugs.debian.org
Subject: dash and sh diversions: wouldn't it be nice to fix 538822 and 540512?
Date: Mon, 29 Oct 2012 20:26:37 +0100
[Message part 1 (text/plain, inline)]
Hi all involved,

[This is a ping].

Reading through RC bug 538822 and 540512 (which were already RC during
Squeeze release in 2010) I have the feeling that it is known how these
bug could be fixed and changes are available in the git repository.
Shouldn't we discuss this with the release team and see if we can upload
the latest changes? I tried to review them, but this is to complicated
for me.

If we can not get this fixed for Wheezy, do we (again) need
release-notes to note the fact? Or just use the Pre-Depends as mentioned
in bug 538822?

Willing to help, if I can.
Paul

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Tue, 30 Oct 2012 06:18:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christian PERRIER <bubulle@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Tue, 30 Oct 2012 06:18:04 GMT) Full text and rfc822 format available.

Message #138 received at 540512@bugs.debian.org (full text, mbox):

From: Christian PERRIER <bubulle@debian.org>
To: Paul Gevers <elbrus@debian.org>, 538822@bugs.debian.org
Cc: 540512@bugs.debian.org
Subject: Re: Bug#538822: dash and sh diversions: wouldn't it be nice to fix 538822 and 540512?
Date: Tue, 30 Oct 2012 06:59:24 +0100
[Message part 1 (text/plain, inline)]
Quoting Paul Gevers (elbrus@debian.org):
> Hi all involved,
> 
> [This is a ping].
> 
> Reading through RC bug 538822 and 540512 (which were already RC during
> Squeeze release in 2010) I have the feeling that it is known how these
> bug could be fixed and changes are available in the git repository.
> Shouldn't we discuss this with the release team and see if we can upload
> the latest changes? I tried to review them, but this is to complicated
> for me.
> 
> If we can not get this fixed for Wheezy, do we (again) need
> release-notes to note the fact? Or just use the Pre-Depends as mentioned
> in bug 538822?
> 
> Willing to help, if I can.


IMHO (not involved in any of these packages), now is bad time to fix
these bugs: too late in the release process.

What's needed is someone taking care of them as soon as possible after
the release of wheezy. Such important and hairy issues should be dealt
with at the beginning of a release cycle and not when we're polishing
things for a release.

My 2 cents, only.


[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Tue, 30 Oct 2012 06:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Tue, 30 Oct 2012 06:27:06 GMT) Full text and rfc822 format available.

Message #143 received at 540512@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Christian PERRIER <bubulle@debian.org>
Cc: 538822@bugs.debian.org, Paul Gevers <elbrus@debian.org>, 540512@bugs.debian.org
Subject: Re: dash and sh diversions: wouldn't it be nice to fix 538822 and 540512?
Date: Mon, 29 Oct 2012 23:24:28 -0700
Christian PERRIER wrote:

> IMHO (not involved in any of these packages), now is bad time to fix
> these bugs: too late in the release process.

Yes, I think we should try to fix the diversion mess in experimental,
ignoring the release cycle, and wait for wheezy+1 or later before
including the changes in sid.

Sorry I dropped the ball on this.  Help testing and tweaking the
patches is always welcome.

On the plus side, this means we have time to make the appropriate
debootstrap improvements to get this working cleanly and well.

Thanks,
Jonathan



Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Wed, 31 Oct 2012 19:15:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Gevers <elbrus@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Wed, 31 Oct 2012 19:15:05 GMT) Full text and rfc822 format available.

Message #148 received at 540512@bugs.debian.org (full text, mbox):

From: Paul Gevers <elbrus@debian.org>
To: 540512@bugs.debian.org, 538822@bugs.debian.org
Subject: Re: Bug#540512: dash and sh diversions: wouldn't it be nice to fix 538822 and 540512?
Date: Wed, 31 Oct 2012 20:11:06 +0100
[Message part 1 (text/plain, inline)]
On 30-10-12 07:24, Jonathan Nieder wrote:
> Christian PERRIER wrote:
> 
>> IMHO (not involved in any of these packages), now is bad time to fix
>> these bugs: too late in the release process.
> 
> Yes, I think we should try to fix the diversion mess in experimental,
> ignoring the release cycle, and wait for wheezy+1 or later before
> including the changes in sid.

So even the pre-depends solution is not an option for this release? I
agree that the patch you propose now is quite involved, but wouldn't it
help to release wheezy with a proper pre-depends and then fix this
properly in wheezy+1? Or do you consider the pre-depends solution too ugly?

> On the plus side, this means we have time to make the appropriate
> debootstrap improvements to get this working cleanly and well.

Of course.

If we don't want to fix this now for wheezy, I will as the release team
to properly tag these bugs.

Paul

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Wed, 07 Nov 2012 19:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Gevers <elbrus@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Wed, 07 Nov 2012 19:45:05 GMT) Full text and rfc822 format available.

Message #153 received at 540512@bugs.debian.org (full text, mbox):

From: Paul Gevers <elbrus@debian.org>
To: Debian release team <debian-release@lists.debian.org>
Cc: 540512@bugs.debian.org, 538822@bugs.debian.org
Subject: Postpone fix for 540512 and 538822 till after release (dash and sh diversions)
Date: Wed, 07 Nov 2012 20:40:58 +0100
[Message part 1 (text/plain, inline)]
Hi release team,

There has been a small discussion about dash RC bugs 538822 and 540512
in the bts and the general idea is to postpone the proper fix (again)
till after the release. Do you agree, and if so, can you tag this bug
appropriate as wheezy-ignore? If you do, these bugs should again
"affects release-notes" as well. I believe the previous text in the
release-notes were fine.

Kind regards
Paul

[signature.asc (application/pgp-signature, attachment)]

Added tag(s) wheezy-ignore. Request was from Neil McGovern <neilm@debian.org> to 538822-submit@bugs.debian.org. (Sat, 26 Jan 2013 12:03:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Sat, 26 Jan 2013 12:03:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil McGovern <neilm@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Sat, 26 Jan 2013 12:03:05 GMT) Full text and rfc822 format available.

Message #160 received at 540512@bugs.debian.org (full text, mbox):

From: Neil McGovern <neilm@debian.org>
To: Paul Gevers <elbrus@debian.org>
Cc: Debian release team <debian-release@lists.debian.org>, 540512@bugs.debian.org, 538822@bugs.debian.org
Subject: Re: Postpone fix for 540512 and 538822 till after release (dash and sh diversions)
Date: Sat, 26 Jan 2013 12:01:54 +0000
[Message part 1 (text/plain, inline)]
Control: tag 540512 +wheezy-ignore
Control: tag 538822 +wheezy-ignore

This is obviously not going to get fixed this time. Adding ignore tags.

On Wed, Nov 07, 2012 at 08:40:58PM +0100, Paul Gevers wrote:
> There has been a small discussion about dash RC bugs 538822 and 540512
> in the bts and the general idea is to postpone the proper fix (again)
> till after the release. Do you agree, and if so, can you tag this bug
> appropriate as wheezy-ignore? If you do, these bugs should again
> "affects release-notes" as well. I believe the previous text in the
> release-notes were fine.
> 

Neil

-- 
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Fri, 30 Aug 2013 16:03:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Gevers <elbrus@debian.org>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Fri, 30 Aug 2013 16:03:04 GMT) Full text and rfc822 format available.

Message #165 received at 540512@bugs.debian.org (full text, mbox):

From: Paul Gevers <elbrus@debian.org>
To: 540512@bugs.debian.org
Subject: ping bug 540512: dash upgrade breaks mksh-as-/bin/sh
Date: Fri, 30 Aug 2013 18:00:14 +0200
[Message part 1 (text/plain, inline)]
Hi,

[Ping to all who have an idea on how to solve this bug]

Wouldn't it be a great time now to try and fix this bug properly, before
we land in jessie freeze and see that we have this bug still open?

Paul

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Gerrit Pape <pape@smarden.org>:
Bug#540512; Package dash. (Tue, 24 Sep 2013 13:30:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thorsten Glaser <t.glaser@tarent.de>:
Extra info received and forwarded to list. Copy sent to Gerrit Pape <pape@smarden.org>. (Tue, 24 Sep 2013 13:30:04 GMT) Full text and rfc822 format available.

Message #170 received at 540512@bugs.debian.org (full text, mbox):

From: Thorsten Glaser <t.glaser@tarent.de>
To: Paul Gevers <elbrus@debian.org>
Cc: 540512@bugs.debian.org
Subject: Re: ping bug 540512: dash upgrade breaks mksh-as-/bin/sh
Date: Tue, 24 Sep 2013 15:27:56 +0200 (CEST)
On Fri, 30 Aug 2013, Paul Gevers wrote:

> [Ping to all who have an idea on how to solve this bug]

Goswin von Brederlow <goswin-v-b@web.de> had a proposal
to fix this using system-shell-* packages that provide
a system-shell virtual essential package.

http://lists.debian.org/debian-devel/2013/05/msg00976.html
is not the correct reference, but this was during the
DebConf in Bosna i Hercegovina… I don’t find it. At that
time, the dash maintainer agreed that other people may
try to fix it, but the bash maintainer gave absolutely
no response at all.

jrnieder also seems to have ideas.

> Wouldn't it be a great time now to try and fix this bug properly, before
> we land in jessie freeze and see that we have this bug still open?

Yesplease!

bye,
//mirabilos
-- 
«MyISAM tables -will- get corrupted eventually. This is a fact of life. »
“mysql is about as much database as ms access” – “MSSQL at least descends
from a database” “it's a rebranded SyBase” “MySQL however was born from a
flatfile and went downhill from there” – “at least jetDB doesn’t claim to
be a database”	‣‣‣ Please, http://deb.li/mysql and MariaDB, finally die!



Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 07:43:40 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.